// This file was generated by Dashcode from Apple Inc.
// You may edit this file to customize your Dashboard widget.
 var lastUpdated = 0;                                 // Track last refresh time to avoid excessive updates
 var lastResults = null;                              // Previous feed contents
 var httpFeedRequest = null;                          // The current XMLHttpRequest
 var loadingAnimationTimer = null;                    // Updates the "Loading..." animation's dots
 var actionIDPref = "actionID";						  // Preference for storing most recently displayed action
 var deferredTaskPref = "deferredTasks";			  // Preference for storing tasks that have been rejected
 var checkedContextPref = "checkedContexts";          // Preference for storing which contexts to pull tasks from


//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    setupParts();
	loadActionName();
}


//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
	
	RefreshScrollArea();
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
	
	// custom stuff starts here
	// if contexts were checked/unchecked, store that in preferences
	UpdateContextPreferences();
	
	// figure out what action to show next
	loadActionName();
	
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}

//
// Function: loadActionName()
// Called whenever we need to figure out what action to show next -- 
// when widget is first loading, when an action is completed or rejected, 
// when we flip to front because the current action's context might not be checked anymore
// 
function loadActionName()
{
	var textAreaToChange = document.getElementById("actionNameText");
	// placeholder text while we're waiting for a real task.
	// textAreaToChange.textContent = getLocalizedString("Checking in with OmniFocus..."); 

	var currentActionID = widget.preferenceForKey(actionIDPref);
	var deferredTasks = widget.preferenceForKey(deferredTaskPref);
	if (!deferredTasks) {
		deferredTasks = "";
	} 
	// if it hasn't been deferred, show the current action
	// TODO: lookupTaskName should let me know if the task has already been completed
	if ((currentActionID) && (deferredTasks.indexOf(currentActionID) == -1)) {
		var cmdLineString = "/usr/bin/osascript lookupTaskName.applescript " + currentActionID;
		}
	else {
		var allowedContexts = widget.preferenceForKey(checkedContextPref);
		if (!allowedContexts) {
			allowedContexts = "";
		}
		var cmdLineString = "/usr/bin/osascript nextTask.applescript " + "\"" + allowedContexts +"\" \""+ deferredTasks + "\"";
	}
	
	widget.system(cmdLineString, ShowNewFocusAction);
};

//
// Function: ShowNewFocusAction(actionInfo)
// Called when we get an action back from OmniFocus
// actionInfo: the result of the AppleScript. So far we only use the outputString, not the errorString
//

function ShowNewFocusAction(actionInfo)
{
	var textAreaToChange = document.getElementById("actionNameText");

	// We got a new action from Focus. The id and name are smooshed togther in one string
	// Store the ID; we'll need it when this task is completed or deferred.
	// var foo = actionInfo.outputString
	if (actionInfo.outputString){
		if ((actionInfo.outputString == "\n") || (actionInfo.outputString == "Can’t get id of missing value.\n")) {
			// we got a response, so Focus is alive
			// but it's not a task, so maybe we've already rejected all the tasks
			var deferredTasks = widget.preferenceForKey(deferredTaskPref);
			if (deferredTasks) {
				// reset the deferred tasks and current task and run it again
				widget.setPreferenceForKey("", deferredTaskPref);
				widget.setPreferenceForKey("", actionIDPref);
				loadActionName()
			}
			else {
				// they really have no actions
				textAreaToChange.textContent = getLocalizedString("No actions available in the selected contexts.");
			}
		}
		else {
			// we got a task, so let's store & display it
			var currentActionID = actionInfo.outputString.split('@')[0];
			widget.setPreferenceForKey(currentActionID, actionIDPref);

			// Display the new task on the widget
			var currentActionName = actionInfo.outputString.split('@')[1];
            fakeActionNameText.textContent = textAreaToChange.textContent;
            textAreaToChange.style.opacity = 0;
			textAreaToChange.textContent = currentActionName;
            
            var itemToFadeIn = textAreaToChange;

            // Fading code
            var fadeHandler = function(a, c, s, f){ itemToFadeIn.style.opacity = c; };
            new AppleAnimator(500, 13, 0.0, 1.0, fadeHandler).start();

            fakeActionNameText.style.opacity = 1;
            var itemToFadeOut = fakeActionNameText;	// replace with name of element to fade

            // Fading code
            var fadeHandler = function(a, c, s, f){ itemToFadeOut.style.opacity = c; };
            new AppleAnimator(500, 13, 1.0, 0.0, fadeHandler).start();

		}
	}
	else {
		// we didn't get a result
		textAreaToChange.textContent = getLocalizedString("OmniFocus could not be contacted; perhaps it is not open.");
//		textAreaToChange.textContent = actionInfo.errorString; // for debugging
	}
};

// Function: SendCompletedAction(event)
// Called when the user clicks the "Done!" button.
// Tells Focus that the action is complete.
//
function SendCompletedAction(event)
{
	var currentActionID = widget.preferenceForKey(actionIDPref);
	var cmdLineString = "/usr/bin/osascript completeTask.applescript " + currentActionID;

	// make sure there is a current task to be completed.
	if (currentActionID != "") {
		// tell Focus to check off the task
		widget.system(cmdLineString, ShowCompletedActionStatus);
	}

};

// Function: ShowCompletedActionStatus(event)
// Called when completeTask.applescript returns. It doesn't do anything yet, but maybe we should 
// show an error if the task wasn't completed, so the user knows to go check off the task in Focus 
//
function ShowCompletedActionStatus(event)
{	
	widget.setPreferenceForKey("", actionIDPref);
	loadActionName();
	// TODO: If completeTask failed, warn the user.
	// TODO: Show status. If it was OK, fade out quickly. If bad, much slower fade. 
};


//
// Function: SkipThisAction(event)
// Called by the "No" button. The user wants to skip this task, so we're going to tell Focus 
// to set its start date in the future, so something else will show up as the next task.
//
function SkipThisAction(event)
{
	// add the task to the list of tasks to ignore
	// (if all available actions end up on the list, we'll flush the list and start over)
	var currentActionID = widget.preferenceForKey(actionIDPref);
	var prevDeferredTasks = widget.preferenceForKey(deferredTaskPref);
	if (prevDeferredTasks) {
		widget.setPreferenceForKey(prevDeferredTasks + " " + currentActionID, deferredTaskPref);
	}
	else {
		widget.setPreferenceForKey(currentActionID, deferredTaskPref);
	}
	// give the user a new task
	loadActionName();

};

//
// Function: refreshContextList()
// Asks OmniFocus for a list of contexts.
// PopulateContextList() will be called when the contexts are received.
//
function RefreshContextList()
{
	// let the user know we're working on something
    ShowLoadingMessage();
	var cmdLineString = "/usr/bin/osascript getContexts.applescript";
	widget.system(cmdLineString, PopulateContextList);
	
};

//
// Function: PopulateContextList(focusContexts)
// Called by the AppleScript that looks up contexts. (That script gets called in the showBack handler.)
// So now we've got a list of contexts and ought to put them into the dropdown
// focusContexts: an xml-ish list of all the contexts in the focus database
//
function PopulateContextList(focusContexts)
{
    HideLoadingMessage();
    if (focusContexts) {
        // Remove the old entries
        ClearContent();

        var results = ParseFocusData(focusContexts);
		// TODO: add checked info from preferences to each entry in results
		//var contextsChecked = RetrieveCheckedContextsFromPrefs();
	   for (var i = 0; i < results.length - 1; i++) {
			results[i].checked = ContextCheckedInPrefs(results[i].id);
		}
        // Got no results?
        if (results == null || results.length < 1) {
            ShowMessageInContents(getLocalizedString("No Items Found"),
                getLocalizedString("The OmniFocus database does not contain any active contexts."));
            return;
        }

        // Generate the display
        AddEntriesToContents(results);

        // update the scrollbar so scrollbar matches new data
        RefreshScrollArea();

        // set lastUpdated to the current time to keep track of the last time a request was posted
        lastUpdated = (new Date).getTime();
    }
    else {
        // document is empty
        ShowMessageInContents(getLocalizedString("No results from OmniFocus"),
                              getLocalizedString("OmniFocus does not appear to be running, or something else has gone horribly wrong."));
    }
};

// Function: parseFocusData(blob)
// Parse a list of actions or contexts from one of the applescripts
//
// Returns the parsed results array.
// blob: the result of an AppleScript, hopefully containing a semi-xml-ish set of Focus contexts (or tasks, theoretically)
//
function ParseFocusData(blob)
{
    var results = new Array;

    // Get all item elements.
	var resultString = blob.outputString;
	
	// the tags used as delimiters to strip out
	var frontString = "<item><name>";
	var tailString = "</id>";
	var itemSplitString = "</item>";
	var dataSplitString = "</name><id>";
	
	
	if (resultString) {
		var items = resultString.split(itemSplitString);
		for (var i = 0; i < items.length - 1; i++) {
			var item = items[i].slice(frontString.length, -tailString.length);
			var itemData = item.split(dataSplitString);
			// put them in the array
			results[results.length] = {
				name: itemData[0],
				id: itemData[1],
			}
		}
		return results;
	}
	else {
		return "";
	}
}

//
// Function: UpdateContextPreferences()
// figures out which contexts are checked and stores that info in a preference so we can look it up later, even next launch
//
function UpdateContextPreferences()
{
// TODO: finish this
	var selectedContexts = new Array;
	// find the contextList
	var contexts = document.getElementsByName("contextBox");
	for (var i = 0; i < contexts.length; i++)
	{
		if (contexts[i].checked) {
		selectedContexts.push(contexts[i].value);
		}
	}
	var smooshedSelectedContexts = selectedContexts.join(" ");
	widget.setPreferenceForKey(smooshedSelectedContexts, checkedContextPref);
	return selectedContexts;
}

//
// Function: ContextCheckedInPrefs(contextID)
// asks preferences whether this context was checked last time, so we can check it now
// contextID: the UUID (as set by OmniFocus) for the context we're interested in
//
function ContextCheckedInPrefs(contextID)
{
	var allCheckedContexts = widget.preferenceForKey(checkedContextPref);
	if (allCheckedContexts) {
		// is it in the list?
		return (allCheckedContexts.indexOf(contextID) != -1);
	}
	// no contexts in list so this one is definitely not in the list
	else return false;
}

//
// Function: createRow(name, index)
// Generate a new row for the content area.
// Returns the created DIV element
// 
// This function was mangled from the example RSS widget and I don't really understand it at all.
//
function CreateRow(contextName, contextID, index, shouldBeChecked)
{
    // create a DIV for the article
    var article = document.createElement("div");
    article.setAttribute("class", "article " + (index % 2 ? "even" : "odd"));
    // if it is not the first article, include a separation line
    if (index > 0) {
        var articleseparator = document.createElement("div");
        articleseparator.setAttribute("class", "articleseparator");
        article.appendChild(articleseparator);
    }

     var articlehead;
        articlehead = document.createElement("span");
    articlehead.setAttribute("class", "articlehead");

    // title of the article
    var subjectElt = MakeEntryDiv(contextName, contextID, shouldBeChecked);
    subjectElt.setAttribute("class", "subject");
    articlehead.appendChild(subjectElt);

    article.appendChild(articlehead);

    return article;
}

//
// Function: makeEntryDiv(content)
// Formats an entry's content as a div for display
//
// content: string or element containing an entry
//
// This function was mangled from the example RSS widget and I don't really understand it at all.
//
function MakeEntryDiv(content, contextID, shouldBeChecked)
{
    var div = document.createElement("div");
	var cbox = document.createElement("input");
	cbox.type = "checkbox";
	cbox.value = contextID;
	cbox.checked = shouldBeChecked;
	cbox.name = "contextBox";
	var label = document.createElement("label");
	label.innerText = content;
	div.appendChild(cbox);
	div.appendChild(label);
	
    return div;
}

//
// Function: AddEntriesToContents(entries)
// Take the parsed results and display them in the content area.
//
// entries: Array of items to display.
// 
// This function was mangled from the example RSS widget and I don't really understand it at all.
//
function AddEntriesToContents(entries)
{
    // copy title and date into rows for display. Store link so it can be used when user
    // clicks on title
    nItems = entries.length;

    var contentElement = document.getElementById("content");
    for (var i = 0; i < nItems; ++i) {
        var item = entries[i];
        var row = CreateRow(item.name, item.id, i, item.checked);

        contentElement.appendChild(row);
    }
}

//
// Function: clearContent()
// Clear the current content area.
// This function was mangled from the example RSS widget and I don't really understand it at all.
//
function ClearContent()
{
    var content = document.getElementById("content");

    if (content) {
        while (content.hasChildNodes()) {
            content.removeChild(content.firstChild);
        }
    }
}

//
// Function: showMessageInContents(title, message)
// Display a status or error message in the content area.
//
// title: Title of message to display.
// message: Message text to display.
// This function was mangled from the example RSS widget and I don't really understand it at all.
//
function ShowMessageInContents(title, message)
{
    ClearContent();

    var titleElement = document.createElement("div");
    titleElement.setAttribute("class", "message-title");
    titleElement.innerText = title;

    var messageElement = document.createElement("div");
    messageElement.setAttribute("class", "message-body");
    messageElement.innerText = message;

    var contentElement = document.getElementById("content");
    contentElement.appendChild(titleElement);
    contentElement.appendChild(messageElement);

    RefreshScrollArea();
}


//
// Function: showLoadingMessage()
// Display "Loading..." and start the dots animating.
// This function was mangled from the example RSS widget and I don't really understand it at all.
//
function ShowLoadingMessage()
{
    showElement("loading-text");
    StartLoadingAnimation();
}

//
// Function: hideLoadingMessage()
// Stop and remove the "Loading..." animation.
// This function was mangled from the example RSS widget and I don't really understand it at all.
//
function HideLoadingMessage()
{
    StopLoadingAnimation();
    hideElement("loading-text");
}

//
// Function: setLoadingText(loadingText)
// Display a message in the "Loading" area.
//
// loadingText: Text to display.
// This function was mangled from the example RSS widget and I don't really understand it at all.
//
function SetLoadingText(loadingText)
{
    var loadingElement = document.getElementById("loading-text");
    if (loadingElement) {
        loadingElement.innerText = loadingText;
        showElement("loading-text");
    }
}

//
// Function: startLoadingAnimation()
// Places animated "Loading..." text on the widget while the feed loads.
// This function was mangled from the example RSS widget and I don't really understand it at all.
//
function StartLoadingAnimation()
{
    var dots = 0;
    var animateLoadingDots = function ()
    {
        var loading = getLocalizedString("Loading");
        for (var i = 0; i < dots; i++) {
            loading = loading + ".";
        }
        SetLoadingText(loading);

        if (++dots > 3) {
            dots = 0;
        }
    };

    animateLoadingDots();
    loadingAnimationTimer = setInterval(animateLoadingDots, 500);
}

//
// Function: stopLoadingAnimation()
// Stop the "Loading..." animation.
// This function was mangled from the example RSS widget and I don't really understand it at all.
//
function StopLoadingAnimation()
{
    if (loadingAnimationTimer != null) {
        clearInterval(loadingAnimationTimer);
        loadingAnimationTimer = null;
    }
}

//
// Function: refreshScrollArea()
// Updates the content areas's scroll bar when the content or article length has changed.
// This function was mangled from the example RSS widget and I don't really understand it at all.
//
function RefreshScrollArea()
{
    var contentarea = document.getElementById("contentarea");
    if (contentarea) contentarea.object.refresh();
}

//
// Function: hideElement(elementId)
// Turn off display for the given element.
//
// elementId: DOM id of the element to hide.
// This function was mangled from the example RSS widget and I don't really understand it at all.
//
function hideElement(elementId)
{
    var element = document.getElementById(elementId);
    if (element)
        element.style.display = "none";
}

//
// Function: showElement(elementId)
// Turn on display for the given element.
//
// elementId: DOM id of the element to show.
// This function was mangled from the example RSS widget and I don't really understand it at all.
//
function showElement(elementId)
{
    var element = document.getElementById(elementId);
    if (element)
        element.style.display = "block";
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
	// custom stuff starts here
	// TODO: This could be slow. Should be moved to somewhere after the back is displayed?
    // Refresh context list if 15 minutes have passed since the last update
    var now = (new Date).getTime();
    if ((now - lastUpdated) > 15 * 60 * 1000) {
        RefreshContextList();
    }
	RefreshScrollArea();
	

}

// Task and Context Objects
function focusTask(id, name, contextID, deferred)
{
	this.id=id;
	this.name=name;
	this.contextID=contextID;
	this.deferred=deferred;
}

function focusContext(id, name, eligible, tasks)
{
	this.id=id;
	this.name=name;
	this.eligible=eligible;
	this.tasks=tasks;
}

// TODO: make it pretty


function revealAction(event)
{
    var actionURL = "omnifocus:///task/" + widget.preferenceForKey(actionIDPref);
    widget.openURL(actionURL);
}
